package body Contenedores.Dispersin_Prueba_Lineal is
	function Disp(E: in TElemento) return Natural is
	begin
		return Pseudoclave(E) mod Max_Elem;
	end Disp;
			
	function Buscar(C: in Tabla_Dispersin;E: in TElemento)
			return Integer is
		Actual, Lmite: Natural;
	begin
		Actual := Disp(E);
		Lmite := Actual;
		-- La clave se busca empezando en la posicin que le corresponde
		-- y continuando hasta encontrarla, hallar una posicin vaca o
		-- volver al punto de partida
		loop
			if not(C.Elementos(Actual).Ocupado) or else
 		    	C.Elementos(Actual).Elemento = E then
				return Actual;
			end if;
			Actual := (Actual + 1) mod Max_Elem;
			exit when Actual = Lmite;
		end loop;
		return -1;	-- No encontrada y no hay huecos
	end Buscar;

	procedure Insertar(C: in out Tabla_Dispersin; E: in TElemento) is
		Actual: Integer;
	begin
		-- Se localiza la posicin en que est o debe estar la clave
		Actual := Buscar(C,E);
		if Actual > -1 then
			-- Se inserta si hay hueco
			if not(C.Elementos(Actual).Ocupado) then
				C.Elementos(Actual) := (E, True);
				C.Num_Elem := C.Num_Elem + 1;
			end if;
		else
			raise Contenedor_Lleno;
		end if;
	end Insertar;

	procedure Extraer(C: in out Tabla_Dispersin; E: in TElemento) is
		Actual: Integer;
		Siguiente, Lmite, Donde_Va: Natural;
	begin
		-- Se localiza la posicin en que debera estar la clave
		Actual := Buscar(C,E);
		if Actual /= -1 and then C.Elementos(Actual).Ocupado then
			-- Si se encontr, se quita dejando libre la posicin
			C.Elementos(Actual).Ocupado := False;
			C.Num_Elem := C.Num_Elem - 1;

			-- Hay que tapar el hueco reubicando las claves posteriores
			-- segn la secuencia de bsqueda			
			Lmite := Actual;
			Siguiente := (Actual + 1) mod Max_elem;
			loop
				exit when not C.Elementos(Siguiente).Ocupado;

				Donde_Va := Disp(C.Elementos(Siguiente).Elemento);
				if Actual < Siguiente then
					-- La zona prohibida est comprendida entre Actual
					-- y Siguiente.
					if Donde_Va <= Actual or Donde_Va > Siguiente then
						C.Elementos(Actual) := C.Elementos(Siguiente);
						C.Elementos(siguiente).Ocupado := False;
						Actual := Siguiente;
					end if;
				else
					-- La zona prohibida abarca desde Siguiente hasta
					-- el final y desde el inicio hasta Actual.
					if Donde_Va <= Actual and Donde_Va > Siguiente then
						C.Elementos(Actual) := C.Elementos(Siguiente);
						C.Elementos(siguiente).Ocupado := False;
						Actual := Siguiente;
					end if;
				end if;
				Siguiente := (Siguiente + 1) mod Max_elem;
				exit when Siguiente = Lmite;
			end loop;
		end if;
	end Extraer;

	procedure Vaciar(C: in out Tabla_Dispersin)  is
	begin
		-- La tabla se vaca marcando todas las posiciones como no ocupadas
		for Pos in C.Elementos'range loop
			C.Elementos(Pos).Ocupado := False;
		end loop;
		C.Num_elem := 0;
	end Vaciar;

	function Est(C: in Tabla_Dispersin; E: in TElemento) return boolean is
		Actual: Integer;
	begin
		-- La clave est si Buscar devuelve una posicin vlida y ocupada
		Actual := Buscar(C,E);
		if Actual /= -1 then
			return C.Elementos(Actual).Ocupado;
		else
			return False;
		end if;
	end Est;

	function Tamao(C: in Tabla_Dispersin) return Natural is
	begin
		return C.Num_Elem;
	end Tamao;
end Contenedores.Dispersin_Prueba_lineal;

