#ifndef INC_CADENAS_SEPARADAS
#define INC_CADENAS_SEPARADAS
    #include <cstdlib>
   using namespace std;
       #include "..\comun\contenedor.h"
template <class T>
   class DispersionCadenasSeparadas: public Contenedor<T>{
      struct Nodo{
         T elemento;
         Nodo     *siguiente;
         Nodo(T e,Nodo *s=NULL):elemento(e),siguiente(s){
         }
      };
      typedef Nodo *PNodo;
      PNodo *elementos;
      int  maxEle;
      int  numEle;
      int dispersion(T e)const{
         return pseudoClave(e)%maxEle;}
      void buscar(T e, PNodo &actual,PNodo &anterior, int &pos) const;
   public:
      DispersionCadenasSeparadas(int );
      ~DispersionCadenasSeparadas();
      void insertar(const T& );
      void extraer(const T& );
      bool encuentra(const T& ) const;
      void vaciar();
      int  cardinal() const{
         return numEle;}
   };

template <class T>
   DispersionCadenasSeparadas<T>::DispersionCadenasSeparadas(int t){
      maxEle=t;
      numEle=0;
      elementos= new PNodo[maxEle];
      for(int i=0; i< maxEle; i++)
         elementos[i]=NULL;
   }
template <class T>
   DispersionCadenasSeparadas<T>::~DispersionCadenasSeparadas(){
      for(int i=0; i< maxEle; i++){
         PNodo actual=elementos[i];
         while(actual != NULL){
            PNodo aux=actual;
            actual=actual->siguiente;
            delete aux;
         }
      }
      delete []elementos;
   }
template <class T>
   void DispersionCadenasSeparadas<T>::buscar(T e, PNodo &actual,PNodo &anterior, int &pos)const{
      pos= dispersion(e);
      actual= elementos[pos];
      anterior= NULL;
      while(actual != NULL && actual->elemento != e){
         anterior = actual;
         actual = actual->siguiente;
      }
   }
template <class T>
   void DispersionCadenasSeparadas<T>::insertar(const T &e){
      PNodo actual, anterior;
      int pos;
      buscar(e, actual,anterior, pos);
      if(actual == NULL){
         elementos[pos] = new Nodo(e,elementos[pos]);
         numEle++;
      }
   }

template <class T>
   void DispersionCadenasSeparadas<T>::extraer(const T &e){
      PNodo actual, anterior;
      int pos;
      buscar(e, actual,anterior, pos);
      if(actual != NULL){
         if(anterior == NULL)
            elementos[pos] = actual->siguiente;
         else
            anterior->siguiente = actual->siguiente;
         delete actual;
         numEle--;
      }
   }

template <class T>
   void DispersionCadenasSeparadas<T>::vaciar(){
      for(int i=0; i< maxEle; i++){
         PNodo actual=elementos[i];
         while(actual != NULL){
            PNodo aux=actual;
            actual=actual->siguiente;
            delete aux;
         }
         elementos[i]=NULL;
      }
      numEle=0;
   }

template <class T>
   bool DispersionCadenasSeparadas<T>::encuentra(const T &e) const{
      PNodo actual, anterior;
      int pos;
      buscar(e, actual,anterior, pos);
      return actual != NULL;
   }
#endif
