#ifndef INC_PRUEBA_LINEAL
#define INC_PRUEBA_LINEAL
#include "..\comun\contenedor.h"
   using namespace std;
template <class T>
   class DispersionPruebaLineal:public Contenedor<T>{
      struct Nodo{
         T elemento;
         bool ocupado;
         Nodo(){
            ocupado=false;}
      };
      Nodo *elementos;
      int  maxEle;
      int  numEle;
      int buscar(const T&) const;
      int dispersion(const T&) const;
   public:
      DispersionPruebaLineal(int t){
         maxEle=t;
         numEle=0;
         elementos= new Nodo[maxEle];
      }
      ~DispersionPruebaLineal(){
         delete []elementos;}
      void insertar(const T&);
      void extraer(const T&);
      bool encuentra(const T&) const;
      void vaciar();
      int  cardinal() const{
         return numEle;}
   };
template <class T>           
   int DispersionPruebaLineal<T>::dispersion(const T &e) const{
      return pseudoClave(e)%maxEle;
   }

template <class T>
   int DispersionPruebaLineal<T>::buscar(const T &e)const{
      int actual, limite;
      limite= actual= dispersion(e);
      do{
         if(!elementos[actual].ocupado ||
           elementos[actual].elemento == e)
            return actual;
         actual = (actual+1) % maxEle;
      }while ( actual!=limite);
      return -1;
   }
template <class T>
   void DispersionPruebaLineal<T>::insertar(const T &e){
      int actual= buscar(e);
      if(actual == -1)
         throw excepcionContenedor("Contenedor lleno");
      if(!elementos[actual].ocupado){
         elementos[actual].ocupado=true;
         elementos[actual].elemento=e;
         numEle++;
      }
   }

template <class T>
   void DispersionPruebaLineal<T>::extraer(const T &e){
      int actual= buscar(e);
      if(actual != -1 && elementos[actual].ocupado){
         elementos[actual].ocupado=false;
         numEle--;
         const int limite=actual;
         int siguiente=(actual+1)%maxEle;
         while (siguiente != limite && elementos[siguiente].ocupado){
            int dondeVa= dispersion(elementos[siguiente].elemento);
            if((actual < siguiente && (dondeVa <= actual || dondeVa > siguiente)) ||
              (actual > siguiente && dondeVa <=actual && dondeVa > siguiente)){
               elementos[actual]=elementos[siguiente];
               elementos[siguiente].ocupado=false;
               actual = siguiente;
            }
            siguiente = (siguiente+1) % maxEle;
         }
      }
   }

template <class T>
   void DispersionPruebaLineal<T>::vaciar(){
      for(int i=0; i<maxEle; i++)
         elementos[i].ocupado=false;
      numEle=0;
   }

template <class T>
   bool DispersionPruebaLineal<T>::encuentra(const T &e) const{
      int actual=buscar(e);
      if(actual == -1) 
         return false;
      return elementos[actual].ocupado;
   }
#endif
