package comn;

import java.io.*;

/**
 * @author juanca
 */
public class Fichero {

    public static class ExcepcionFichero extends RuntimeException {
        public ExcepcionFichero(Exception e) {
            super(e);
        }
        public ExcepcionFichero(String r) {
            super(r);
        }
    }

    static public final int dirNula = -1;
    RandomAccessFile fichero;
    String nombre;
    public void crear(String nom) {
        cerrar();
        nombre=nom;
        File manejador = new File(nombre);
        if (manejador.exists())
            if(!manejador.delete())
                throw new ExcepcionFichero("El fichero no se ha podido borrar");
        try {
            fichero = new RandomAccessFile(nombre, "rw");
        } catch (FileNotFoundException e) {
            throw new ExcepcionFichero(e);
        }
    }

    public void abrir(String nom) {
        cerrar();
        nombre=nom;
        try {
            fichero = new RandomAccessFile(nombre, "rw");
        } catch (FileNotFoundException e) {
            throw new ExcepcionFichero(e);
        }
    }

    public void cerrar() {
        try {
            if(fichero!=null){
               fichero.close();
               fichero=null;
            }
        } catch (IOException e) {
            throw new ExcepcionFichero(e);
        }
    }

    public long tamao() {
        try {
            return fichero.length();
        } catch (IOException e) {
            throw new ExcepcionFichero(e);
        }
    }

    public boolean abierto() {
        return fichero != null;
    }
    public void posicionar(long pos) {
        try {
            fichero.seek(pos);
        } catch (IOException e) {
            throw new ExcepcionFichero(e);
        }
    }
    public byte leer() {
        try {
            return fichero.readByte();
        } catch (IOException e) {
            throw new ExcepcionFichero(e);
        }
    }

    public void escribir(byte dato) {
        try {
            fichero.writeByte(dato);
        } catch (IOException e) {
            throw new ExcepcionFichero(e);
        }
    }
    public byte[] leer(int lon) {
        try {
            byte datos[]= new byte[lon];
            long tama = fichero.length();
            long pos = fichero.getFilePointer();
            int leido=fichero.read(datos);
            if(leido != lon)
              throw new ExcepcionFichero("Error en lectura de un fichero");     
            return datos;
        } catch (IOException e) {
            throw new ExcepcionFichero(e);
        }
    }

    public void escribir(byte dato[]) {
        try {
            fichero.write(dato);
        } catch (IOException e) {
            throw new ExcepcionFichero(e);
        }
    }
}

