package comn;

import comn.Fichero;

/**
 * @author juanca
 */
public class FicheroAvanzado extends Fichero {
    //Atributos enteros almacenados al principio al principio del fichero 
    int    numeroAdjuntos; //Nmero de datos enteros aadidos
    int    listaVacas;    //Lista de pginas vacas
    int    desplazamiento; //Inicio de datos cliente
    int    tamaoPgina;   //Tamao de cada pgina
    int    adjuntos[];     //Datos adjuntos al fichero

//  Realizan las operaciones correspondientes sobre el fichero
    void posicionarInterno(long pos) {
        super.posicionar(pos);
    }
    byte[] leerInterno(int lon){
        return super.leer(lon);
    }
    void escribirInterno(byte []dato){
        super.escribir(dato);
    }
    public void posicionar(long pos) {
        posicionarInterno(desplazamiento+pos*tamaoPgina);
    }
    public int  tomarPgina() {
        if(listaVacas==dirNula) 
            return (int)tamao();
         int pnueva=listaVacas;
         posicionar(listaVacas);
         listaVacas=Conversor.aInt(super.leer(4));
         posicionarInterno(2*Conversor.INTBYTES);
         escribirInterno(Conversor.aByte(listaVacas));
         return pnueva;
    }
    public void  liberarPgina(int pos) {
        posicionar(pos);
        escribirInterno(Conversor.aByte(listaVacas));
        listaVacas=pos;
        posicionarInterno(2*Conversor.INTBYTES);
        escribirInterno(Conversor.aByte(listaVacas));
    }
    public void crear(String nombre, int lp){
        crear(nombre,lp,0);
    }
    public void crear(String nombre, int lp, int adj){
        super.crear(nombre);
        tamaoPgina=lp;
        numeroAdjuntos=adj;
        listaVacas=dirNula;
        desplazamiento=(3+numeroAdjuntos)*Conversor.INTBYTES;
        posicionarInterno(0);
        escribirInterno(Conversor.aByte(tamaoPgina));
        escribirInterno(Conversor.aByte(numeroAdjuntos));
        escribirInterno(Conversor.aByte(listaVacas));
        if(numeroAdjuntos>0) { //Escribimos los adjuntos en el fichero
           adjuntos = new int[numeroAdjuntos];
           for(int i=0;  i<numeroAdjuntos;i++){
               adjuntos[i]=0;
               escribirInterno(Conversor.aByte(0));
           }
        }
    }
    public void abrir(String nombre){
        super.abrir(nombre);
        if(super.tamao()<Conversor.INTBYTES*2)
            throw new ExcepcionFichero("Error al abrir el fichero");
        posicionarInterno(0);
        tamaoPgina=Conversor.aInt(leerInterno(Conversor.INTBYTES));
        numeroAdjuntos=Conversor.aInt(leerInterno(Conversor.INTBYTES));
        listaVacas=Conversor.aInt(leerInterno(Conversor.INTBYTES));
        if(numeroAdjuntos>0) {
            adjuntos = new int[numeroAdjuntos];
            for(int i=0;  i<numeroAdjuntos;i++){
                adjuntos[i]=Conversor.aInt(leerInterno(Conversor.INTBYTES));
            }
        }
        desplazamiento=(3+numeroAdjuntos)*Conversor.INTBYTES;
    }
    public int  adjunto(int pos ){      //devuelve el valor del adjunto indicado
        return adjuntos[pos];
    }
    public void adjunto(int pos, int valor){ //Modifica el valor del adjunto indicado
        adjuntos[pos]=valor;
        posicionarInterno((3+pos)*Conversor.INTBYTES);
        escribirInterno(Conversor.aByte(valor));
    }
    public long  tamao(){
        return (super.tamao()-desplazamiento)/tamaoPgina;
    }
    public byte[] leer(int pos){
        posicionar(pos);
        return leerInterno(tamaoPgina);
    }
    public void escribir(byte[] dato,long pos){
        if(dato.length>tamaoPgina)
            throw new ExcepcionFichero("Intento de almacenar un dato mayor del permitido"); 
        posicionar(pos);
        if(dato.length < tamaoPgina) {
            byte[] nuevoDato= new byte[tamaoPgina];
            for(int i=0; i<dato.length; i++)
                nuevoDato[i]=dato[i];
            dato=nuevoDato;
        }    
        escribirInterno(dato);
    };
   }
